﻿Type=Class
Version=6.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
Sub Class_Globals
	Private aAct As Activity
	Private aPnlInput As Panel
	Private aFirstEditText As EditText
	Private pnlScreen As Panel
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(act As Activity, pnlInput As Panel, firstEditText As EditText)
	aAct = act
	aPnlInput = pnlInput
	aFirstEditText = firstEditText
End Sub

Public Sub Show
	pnlScreen.Initialize("pnlScreen")
	aAct.AddView(pnlScreen, 0, 0, aAct.Width, aAct.Height)
	pnlScreen.Color = Colors.ARGB(150, 0, 0, 0)
	pnlScreen.BringToFront
	
	aPnlInput.RemoveView
	pnlScreen.AddView(aPnlInput, _
	                 (aAct.Width - aPnlInput.Width)/2, _
									 (aAct.Height - aPnlInput.Height)/2, _
									 aPnlInput.Width, aPnlInput.Height)
									 
	aFirstEditText.RequestFocus
	
	' for all EditText fields set the eventhandler for KeyPress
	For Each v As View In aPnlInput.GetAllViewsRecursive
		If v Is EditText Then
			SetReflector(v)
		End If
	Next
End Sub

Public Sub SetReflector(v As View)
	Dim r As Reflector
	r.Target = v
	r.SetOnKeyListener("On_KeyPress")
	r.RunMethod2("setFocusable", "True", "java.lang.boolean")
	r.RunMethod2("setFocusableInTouchMode", "True", "java.lang.boolean")
End Sub

Private Sub Hide
	pnlScreen.RemoveView
End Sub

Private Sub pnlScreen_Click
	' Do Nothing: Prevent panel from click
End Sub

Private Sub On_KeyPress(ViewTag As Object, KeyCode As Int, KeyEvent As Object) As Boolean
	If KeyCode = KeyCodes.KEYCODE_BACK Then 
		Log("On_KeyPress")
	  Hide
	  Return True
	Else
		Return False
	End If
End Sub